---
title: Autoplay guide for media and Web Audio APIs
slug: Web/Media/Autoplay_guide
tags:
  - API
  - Audio
  - Draft
  - Guide
  - HTML
  - JavaScript
  - Media
  - Muting
  - Playback
  - Video
  - Web
  - Web Audio API
  - autoplay
  - mute
  - muted
  - play
---
<p>Automatically starting the playback of audio (or videos with audio tracks) immediately upon page load can be an unwelcome surprise to users. While autoplay of media serves a useful purpose, it should be used carefully and only when needed. In order to give users control over this, browsers often provide various forms of autoplay blocking. <span class="seoSummary">In this guide, we'll cover autoplay functionality in the various media and Web Audio APIs, including a brief overview of how to use autoplay and how to work with browsers to handle autoplay blocking gracefully.</span></p>

<p>Autoplay blocking is <em>not</em> applied to {{HTMLElement("video")}} elements when the source media does not have an audio track, or if the audio track is muted. Media with an active audio track are considered to be <strong>audible</strong>, and autoplay blocking applies to them. <strong>Inaudible</strong> media are not affected by autoplay blocking.</p>

<h2 id="Autoplay_and_autoplay_blocking">Autoplay and autoplay blocking</h2>

<p>The term <strong>autoplay</strong> refers to any feature that causes audio to begin to play without the user specifically requesting that playback begin. This includes both the use of HTML attributes to autoplay media as well as the user of JavaScript code to start playback outside the context of handling user input.</p>

<p>That means that both of the following are considered autoplay behavior, and are therefore subject to the browser's autoplay blocking policy:</p>

<pre class="brush: html notranslate">&lt;audio src="/music.mp4" autoplay&gt;</pre>

<p>and</p>

<pre class="brush: js notranslate">audioElement.play();</pre>

<p>The following web features and APIs may be affected by autoplay blocking:</p>

<ul>
 <li>The {{Glossary("HTML")}} {{HTMLElement("audio")}} and {{HTMLElement("video")}} elements</li>
 <li>The <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
</ul>

<p>From the user's perspective, a web page or app that spontaneously starts making noise without warning can be jarring, inconvenient, or off-putting. Because of that, browsers generally only allow autoplay to occur successfully under specific circumstances.</p>

<h3 id="Autoplay_availability">Autoplay availability</h3>

<p>As a general rule, you can assume that media will be allowed to autoplay only if <em>at least one</em> of the following is true:</p>

<ul>
 <li>The audio is muted or its volume is set to 0</li>
 <li>The user has interacted with the site (by clicking, tapping, pressing keys, etc.)</li>
 <li>If the site has been whitelisted; this may happen either automatically if the browser determines that the user engages with media frequently, or manually through preferences or other user interface features</li>
 <li>If the autoplay feature policy is used to grant autoplay support to an {{HTMLElement("iframe")}} and its document.</li>
</ul>

<p>Otherwise, the playback will likely be blocked. The exact situations that result in blocking, and the specifics of how sites become whitelisted vary from browser to browser, but the above are good guidelines to go by.</p>

<p>For details, see the auto-play policies for <a href="https://developers.google.com/web/updates/2017/09/autoplay-policy-changes">Google Chrome</a> and <a href="https://webkit.org/blog/7734/auto-play-policy-changes-for-macos/">WebKit</a>.</p>

<div class="notecard note">
<p><strong>Note:</strong> Put another way, playback of any media that includes audio is generally blocked if the playback is programmatically initiated in a tab which has not yet had any user interaction. Browsers may additionally choose to block under other circumstances.</p>
</div>

<h2 id="Autoplay_of_media_elements">Autoplay of media elements</h2>

<p>Now that we've covered what autoplay is and what can prevent autoplay from being allowed, we'll look at how your web site or app can automatically play media upon page load, how to detect when autoplay fails to occur, and tips for coping when autoplay is denied by the browser.</p>

<h3 id="The_autoplay_attribute">The autoplay attribute</h3>

<p>The simplest way to automatically play content is to add the {{htmlattrxref("autoplay", "audio")}} attribute to your {{HTMLElement("audio")}} or {{HTMLElement("video")}} element. This sets the {{domxref("HTMLMediaElement.autoplay", "autoplay")}} property on the element to <code>true</code>, and when <code>autoplay</code> is <code>true</code>, the media will automatically begin to play as soon as possible after the following have occurred:</p>

<ul>
 <li>The page is allowed to use autoplay functionality</li>
 <li>The element has been created during page load</li>
 <li>Enough media has been received to begin playback and continue to play through to the end of the media without interruption, assuming there are no dramatic changes in network performance or bandwidth.</li>
</ul>

<h4 id="Example_The_autoplay_attribute">Example: The autoplay attribute</h4>

<p>An {{HTMLElement("audio")}} element using the <code>autoplay</code> attribute might look like this:</p>

<pre class="brush: html notranslate">&lt;audio id="musicplayer" autoplay&gt;
  &lt;source src="/music/chapter1.mp4"&gt;
&lt;/audio&gt;
</pre>

<h4 id="Example_2_Detecting_autoplay_failure">Example 2: Detecting autoplay failure</h4>

<p>If you rely on autoplay for anything important, or if autoplay failure will impact your app in any way, you will probably want to be able to tell when it autoplay didn't begin. Unfortunately, in the case of the {{htmlattrxref("autoplay", "audio")}} attribute, recognizing whether or not autoplay successfully began is tricky. There's not an event triggered when autoplay fails. Nor is there an exception thrown or a callback you can set up or even a flag on the media element that tells you if autoplay worked. All you can really do is examine a few values and make an educated guess as to whether or not autoplay worked.</p>

<p>A better approach, if you're able to adjust the direction you look at things from, is to instead rely on knowing that playback of the media has successfully started, instead of when it fails to start. You can do this easily, by listening for the {{event("play")}} event to be fired on the media element.</p>

<p>The <code>play</code> event is sent both when the media is resumed after being paused <em>and</em> when autoplay occurs. That means that the first time the <code>play</code> event is fired, you know your media is being started for the first time after the page is opened.</p>

<p>Consider this HTML for a media element:</p>

<pre class="brush: html notranslate">&lt;video src="myvideo.mp4" autoplay onplay=handleFirstPlay(event)"&gt;</pre>

<p>Here we have a {{HTMLElement("video")}} element whose {{htmlattrxref("autoplay", "video")}} attribute is set, with an {{domxref("HTMLMediaElement.onplay", "onplay")}} event handler set up; the event is handled by a function called <code>handleFirstPlay()</code>, which receives as input the <code>play</code> event.</p>

<p><code>handleFirstPlay()</code> looks like this:</p>

<pre class="brush: js notranslate">function handleFirstPlay(event) {
  let vid = event.target;

  vid.onplay = null;

  // Start whatever you need to do after playback has started
}</pre>

<p>After getting a reference to the video element from the {{domxref("Event")}} object's {{domxref("Event.target", "target")}}, the element's <code>onplay</code> handler is set to <code>null</code>. This will prevent any future <code>play</code> events from being delivered to the handler. That could happen if the video is paused and resumed by the user or automatically by the browser when the document is in a background tab.</p>

<p>At this point, your site or app can begin whatever it needs to do that relies upon the video having been started up.</p>

<div class="notecard note">
<p><strong>Note:</strong> This approach doesn't differentiate between autoplay and the user starting playback manually.</p>
</div>

<h3 id="The_play_method">The play() method</h3>

<p>The term "autoplay" also refers to scenarios in which a script tries to trigger the playback of media that includes audio, outside the context of handling a user input event. This is done by calling the media element's {{domxref("HTMLMediaElement.play", "play()")}} method.</p>

<div class="notecard note">
<p><strong>Note:</strong> It is strongly recommended that you use the <code>autoplay</code> attribute whenever possible, because support for autoplay preferences are more widespread for the <code>autoplay</code> attribute than for other means of playing media automatically. It also lets the browser take responsibility for starting playback, letting it optimize the timing of that taking place.</p>
</div>

<h4 id="Example_Playing_video">Example: Playing video</h4>

<p>This simple example plays the first {{HTMLElement("video")}} element found in the document. <code>play()</code> won't let the playback begin unless the document has permission to automatically play media.</p>

<pre class="brush: js notranslate">document.querySelector("video").play();</pre>

<h4 id="Example_Handling_play_failures">Example: Handling play() failures</h4>

<p>It's much easier to detect a failure to autoplay media when you use the {{domxref("HTMLMediaElement.play", "play()")}} method to start it. <code>play()</code> returns a {{jsxref("Promise")}} which is resolved once the media successfully begins to play, and is rejected when playback fails to begin (such as if autoplay is denied). When autoplay fails, you likely will want to offer a way for the user to manually tell the browser to ask the user to grant permission to play media.</p>

<p>You might use code like this to accomplish the job:</p>

<pre class="brush: js notranslate">let startPlayPromise = videoElem.play();

if (startPlayPromise !== undefined) {
  startPlayPromise.then(() =&gt; {
    // Start whatever you need to do only after playback
    // has begun.
  }).catch(error =&gt; {
    if (error.name === "NotAllowedError") {
      showPlayButton(videoElem);
    } else {
      // Handle a load or playback error
    }
  });
}
</pre>

<p>The first thing we do with the result of <code>play()</code> is make sure it's not <code>undefined</code>. We check for this because in earlier versions of the HTML specification, <code>play()</code> didn't return a value. Returning a promise to allow you to determine success or failure of the operation was added more recently. Checking for <code>undefined</code> prevents this code from failing with an error on older versions of web browsers.</p>

<p>If the promise returned by <code>play()</code> is resolved without error, the <code>then()</code> clause is run and can begin whatever needs to be done when autoplay has begun.</p>

<p>We then add a {{jsxref("Promise.catch", "catch()")}} handler to the promise. This looks at the error's {{domxref("DOMException.name", "name")}} to see if it's <code>NotAllowedError</code>. This indicates that playback failed due to a permission issue, such as autoplay being denied. If that's the case, we should present a user interface to let the user manually start playback; that's handled here by a function <code>showPlayButton()</code>.</p>

<p>Any other errors are handled as appropriate.</p>

<h2 id="Autoplay_using_the_Web_Audio_API">Autoplay using the Web Audio API</h2>

<p>In the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>, a web site or app can start playing audio using the <code>start()</code> method on a source node linked to the {{domxref("AudioContext")}}. Doing so outside the context of handling a user input event is subject to autoplay rules.</p>

<p><em>More content will come soon; autoplay blocking is still being worked on at Mozilla. If others have it already, they are welcome to pitch in with this section...</em></p>

<h2 id="The_autoplay_feature_policy">The autoplay feature policy</h2>

<p>In addition to the browser-side management and control over autoplay functionality described above, a web server can also express its willingness to allow autoplay to function. The {{Glossary("HTTP")}} {{HTTPHeader("Feature-Policy")}} header's <code><a href="/en-US/docs/Web/HTTP/Headers/Feature-Policy/autoplay">autoplay</a></code> directive is used to control which domains, if any, can be used to autoplay media. By default, the <code>autoplay</code> feature policy is set to <code>'self'</code> (<em>including the single quote characters</em>), indicating that autoplay is permitted as they're hosted on the same domain as the document.</p>

<p>You can also specify <code>'none'</code> to disable autoplay entirely, <code>'*'</code> to allow autoplay from all domains, or one or more specific origins from which media can be automatically played. These origins are separated by space characters.</p>

<div class="notecard note">
<p><strong>Note:</strong> The specified feature policy applies to the document and every {{HTMLElement("iframe")}} nested within it, unless those frames include an {{htmlattrxref("allow", "iframe")}}, which sets a new feature policy for that frame and all frames nested within it.</p>
</div>

<p>When using the {{htmlattrxref("allow", "iframe")}} attribute on an <code>&lt;iframe&gt;</code> to specify a feature policy for that frame and its nested frames, you can also specify the value <code>'src'</code> to allow autoplay of media only from the same domain as that specified by the frame's {{htmlattrxref("src", "iframe")}} attribute.</p>

<h3 id="Example_Allowing_autoplay_only_from_the_documents_domain">Example: Allowing autoplay only from the document's domain</h3>

<p>To use the {{HTTPHeader("Feature-Policy")}} header to only allow media to autoplay from the document's {{Glossary("origin")}}:</p>

<pre class="notranslate">Feature-Policy: autoplay 'self'</pre>

<p>To do the same for an {{HTMLElement("iframe")}}:</p>

<pre class="brush: html notranslate">&lt;iframe src="mediaplayer.html"
        allow="autoplay 'src'"&gt;
&lt;/iframe&gt;
</pre>

<h3 id="Example_Allowing_autoplay_and_fullscreen_mode">Example: Allowing autoplay and fullscreen mode</h3>

<p>Adding <a href="/en-US/docs/Web/API/Fullscreen_API">Fullscreen API</a> permission to the previous example results in a <code>Feature-Policy</code> header like the following if fullscreen access is allowed regardless of the domain; a domain restriction can be added as well as needed.</p>

<pre class="notranslate">Feature-Policy: autoplay 'self'; fullscreen</pre>

<p>The same permissions, grated using the <code>&lt;iframe&gt;</code> element's <code>allow</code> property, look like this:</p>

<pre class="brush: html notranslate">&lt;iframe src="mediaplayer.html"
        allow="autoplay 'src'; fullscreen"&gt;
&lt;/iframe&gt;
</pre>

<h3 id="Example_Allowing_autoplay_from_specific_sources">Example: Allowing autoplay from specific sources</h3>

<p>The <code>Feature-Policy</code> header to allow media to be played from both the document's (or <code>&lt;iframe&gt;</code>'s) own domain and <code>https://example.media</code> looks like this:</p>

<pre class="notranslate">Feature-Policy: autoplay 'self' https://example.media</pre>

<p>An {{HTMLElement("iframe")}} can be written to specify that this autoplay policy should be applied to itself and any child frames would be written thusly:</p>

<pre class="brush: html notranslate">&lt;iframe width="300" height="200"
        src="mediaplayer.html"
        allow="autoplay 'src' https://example.media"&gt;
&lt;/iframe&gt;
</pre>

<h3 id="Example_Disabling_autoplay">Example: Disabling autoplay</h3>

<p>Setting the <code>autoplay</code> feature policy to <code>'none'</code> disables autoplay entirely for the document or <code>&lt;iframe&gt;</code> and all nested frames. The HTTP header is:</p>

<pre class="notranslate">Feature-Policy: autoplay 'none'</pre>

<p>Using the <code>&lt;iframe&gt;</code>'s <code>allow</code> attribute:</p>

<pre class="brush: html notranslate">&lt;iframe src="mediaplayer.html"
        allow="autoplay 'none'"&gt;
&lt;/iframe&gt;
</pre>

<h2 id="Best_practices">Best practices</h2>

<p>Tips and recommended best practices to help you make the most of working with autoplay are offered here.</p>

<h3 id="Handling_autoplay_failure_with_media_controls">Handling autoplay failure with media controls</h3>

<p>A common use case for autoplay is to automatically begin to play a video clip that goes along with an article, an advertisement, or a preview of the page's main functionality. To autoplay videos like these, you have two options: don't have an audio track, or have an audio track but configure the {{HTMLElement("video")}} element to mute the audio by default, like this:</p>

<pre class="brush: html notranslate">&lt;video src="/videos/awesomevid.webm" controls autoplay playsinline muted&gt;</pre>

<p>This video element is configured to include the user controls (typically play/pause, scrubbing through the video's timeline, volume control, and muting); also, since the {{htmlattrxref("muted", "video")}} attribute is included, and the {{htmlattrxref("playsinline", "video")}} attribute that is required for autoplay in Safari, the video will autoplay but with the audio muted. The user has the option, however, of re-enabling the audio by clicking on the unmute button in the controls.</p>

<h2 id="Browser_configuration_options">Browser configuration options</h2>

<p>Browsers may have preferences that control the way autoplay works, or how autoplay blocking is handled. Here, any such preferences that may be of special significance or importance to you as a web developer are listed. These include any that may aid in testing or debugging as well as any that could be set in a way that you need to be prepared to handle.</p>

<h3 id="Firefox">Firefox</h3>

<dl>
 <dt><code>media.allowed-to-play.enabled</code></dt>
 <dd>A Boolean preference which specifies whether or not the {{domxref("HTMLMediaElement.allowedToPlay")}} property is exposed to the web. This is currently <code>false</code> by default (except in nightly builds, where it's <code>true</code> by default). If this is <code>false</code>, the <code>allowedToPlay</code> property is missing from the <code>HTMLMediaElement</code> interface, and is thus not present on either {{HTMLElement("audio")}} or {{HTMLElement("video")}} elements.</dd>
 <dt><code>media.autoplay.allow-extension-background-pages</code></dt>
 <dd>This Boolean preference, if <code>true</code>, allows browser extensions' background scripts to autoplay audio media. Setting this value to <code>false</code> disables this capability. The default value is <code>true</code>.</dd>
 <dt><code>media.autoplay.allow-muted</code></dt>
 <dd>A Boolean preference which if <code>true</code> (the default) allows audio media which is currently muted to be automatically played. If this has been changed to <code>false</code>, media with an audio track will not be permitted to play even if muted.</dd>
 <dt><code>media.autoplay.block-webaudio</code></dt>
 <dd>A Boolean preference which indicates whether or not to apply autoplay blocking to the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>. The default is <code>true</code>.</dd>
 <dt><code>media.autoplay.default</code></dt>
 <dd>An integer preference which specifies whether per-domain configuration for autoplay support by default is allowed (<code>0</code>), blocked (<code>1</code>), or prompt-on-use (<code>2</code>). The default value is <code>0</code>.</dd>
 <dt><code>media.autoplay.enabled.user-gestures-needed</code> (Nightly builds only)</dt>
 <dd>A Boolean preference which controls whether or not detection of user gestures is allowed to override the setting of <code>media.autoplay.default</code>. If <code>media.autoplay.default</code> is <em>not</em> set to <code>0</code> (autoplay allowed by default), this preference being <code>true</code> allows autoplay of media with audio tracks anyway if the page has been activated by user gestures, and media that isn't audible is not restricted at all.</dd>
 <dt><code>media.block-autoplay-until-in-foreground</code></dt>
 <dd>A Boolean preference which indicates whether or not media playback is blocked when started on a background tab. The default value, <code>true</code>, means that even when otherwise available, autoplay won't take place until after a tab is brought to the foreground. This prevents the distracting situation in which a tab begins playing sound and the user can't find the tab among all their tabs and windows.</dd>
</dl>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
 <li><a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Video and audio content</a> (Learning guide)</li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/Apps/Fundamentals/Audio_and_video_delivery/Cross-browser_audio_basics">Cross-browser audio basics</a></li>
</ul>
